class CasesController < ApplicationController

  def index
    # TODO the following block is using the Squirrel plugin, which isn't really required
    #      now that Rails has scopes ... need to replace this and the paginate code:
    cases = Case.find(:all) do
      if params[:_search] == "true"
        number =~ "%#{params[:number]}%" if params[:number].present?
      end
      paginate :page => params[:page], :per_page => params[:rows]      
      order_by "#{params[:sidx]} #{params[:sord]}"
    end

    if request.xhr?
      render :json => cases.to_json_for_jqgrid_with_firms_and_attorneys_for_case(params[:page], params[:rows], 
                                                cases.total_entries
                                               ) and return
    end

  end
  
  def update
    # for demo purposes let's do nothing:
    render :nothing => true and return
  end
  
  def get_firms_for_case
    @firms = Firm.all
    render :partial => 'select_firms', :layout => false
  end
  
  def get_attorneys_for_firm
    params[:id] = '0'  if params[:id].blank?
    # params[:id] == 0(zero) or nil -- means no Firms have been selected for this Case:
    @attorneys = Array.new(1, User.new)  if params[:id] == '0'  # an array of 1 with an empty attorney
    @attorneys = User.find_all_by_firm_id(params[:id])  unless params[:id] == '0'
    render :partial => 'select_attorneys', :layout => false
  end

end
